;------------------------------------------------------------------------------
;	TimpyH_MSD_MMC_Command.asm
;------------------------------------------------------------------------------
;
;	Copyright 2006, 2007 Chiaki Nakajima
;	Original copyright 2006 Silicon Laboratories, Inc.
;
;	Release 1.1
;	E\[X̐
;	EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
;	Et@C"F34x_""TimpyH_"ɕύX
;
;	Release 1.0
;	ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
;	ESDCCֈڐA
;	Esvȋ@\폜
;
;-------------------------------------------------------------------------------
;
;	Copyright 2006 Silicon Laboratories, Inc.
;	http://www.silabs.com
;
;	Release 1.1
;	    -All changes by PKC
;	    -09 JUN 2006
;	    -Removed individual SFR definitions and included c8051f340.inc
;
;	Release 1.0
;	    -Initial Release
;
;-------------------------------------------------------------------------------

.area 		MMC_COMMAND 	(rel,con,code)

.globl 		_Read_Bytes
.globl 		_Write_Bytes

;-------------------------------------------------------------------------------
; 	function Read_Bytes
;
;	argument DPTR : pchar
;	__data current_blklen : buffer length
;
_Read_Bytes:
		push		ACC
		mov		A, r4
		push		ACC
		mov		A, r5
		push		ACC
		;
		;					;[LOWX^
		mov		r5, _current_blklen		;R5 : current_blklen(L)
		mov		r4, _current_blklen + 1		;R4 : current_blklen(H)
		;
		;					;current_blklen == 0ȂI
		mov		A, r5
		orl		A, r4
		jz		_ReadBytesFinish		;current_blklen == 0ȂWv
		;
		;					;current_blklen(L) != 0ȂR41ZĂ
		mov		A, r5
		jz		_ReadBytesLoop
		;
		inc		r4				;r4 += 1
		;
_ReadBytesLoop:						;[h[v
		mov		_SPI0DAT, #0xff			;[ĥ߂0xffo
		jnb   		_SPIF, .			;]I҂
		;
		clr		_SPIF
		mov		A, _SPI0DAT			;A : [hf[^
		movx		@DPTR, A			;obt@֓]
		inc		DPTR				;|C^XV
		;
		djnz		r5, _ReadBytesLoop
		;
		djnz		r4, _ReadBytesLoop
		;
_ReadBytesFinish:					;I
		pop		ACC
		mov		r5, A
		pop		ACC
		mov		r4, A
		pop		ACC
		;
		ret					;^[
		;
;-------------------------------------------------------------------------------
; 	function Write_Bytes
;
;	argument DPTR : pchar
;	__data current_blklen : buffer length
;
_Write_Bytes:
		push		ACC
		mov		A, r4
		push		ACC
		mov		A, r5
		push		ACC
		;
		;					;[LOWX^
		mov		r5, _current_blklen		;R5 : current_blklen(L)
		mov		r4, _current_blklen + 1		;R4 : current_blklen(H)
		;
		;					;current_blklen == 0ȂI
		mov		A, r5
		orl		A, r4
		jz		_WriteBytesFinish		;current_blklen == 0ȂWv
		;
		;					;current_blklen(L) != 0ȂR41ZĂ
		mov		A, r5
		jz		_WriteBytesLoop
		;
		inc		r4				;r4 += 1
		;
_WriteBytesLoop:					;Cg[v
		movx		A, @DPTR			;A : Cgf[^
		mov		_SPI0DAT, A			;SPIo
		jnb		_SPIF, .			;]I҂
		;
		clr		_SPIF
		inc		DPTR				;|C^XV
		;
		djnz		r5, _WriteBytesLoop
		;
		djnz		r4, _WriteBytesLoop
		;
_WriteBytesFinish:					;I
		pop		ACC
		mov		r5, A
		pop		ACC
		mov		r4, A
		pop		ACC
		;
		ret
		;
;------------------------------------------------------------------------------
;	End of TimpyH_MSD_MMC_Command.asm
;------------------------------------------------------------------------------
