;------------------------------------------------------------------------------
;	TimpyH_MSD_USB_Procedure.asm
;------------------------------------------------------------------------------
;
;	Copyright 2006, 2007 Chiaki Nakajima
;	Original copyright 2006 Silicon Laboratories, Inc.
;
;	Release 1.1
;	E\[X̐
;	EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
;	Et@C"F34x_""TimpyH_"ɕύX
;
;	Release 1.0
;	ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
;	ESDCCֈڐA
;	Esvȋ@\폜
;
;-------------------------------------------------------------------------------
;
;	Copyright 2006 Silicon Laboratories, Inc.
;	http://www.silabs.com
;
;	Release 1.1
;	    -All changes by PKC
;	    -09 JUN 2006
;	    -Removed individual SFR definitions and included c8051f340.inc
;
;	Release 1.0
;	    -Initial Release
;
;-------------------------------------------------------------------------------

.area		USB_PROCEDURE 	(rel,con,code)

.globl		_Fifo_Write
.globl		_Fifo_Read

;-------------------------------------------------------------------------------
; 	function FIFO_WRITE
;
;	__data Fifo_RW_Buf_Ptr : pchar
;	__data Fifo_RW_Buf_Length : buffer length
;	__data Fifo_RW_Ep_Address : register address
;
_Fifo_Write:
		push		ACC
		mov		A, R0
		push		ACC
		mov		A, R4
		push		ACC
		mov		A, R5
		push		ACC
		push		DPL
		push		DPH
		;
		;					;[LOWX^
		mov		r5, _Fifo_RW_Buf_Length		;R5 : _Fifo_RW_Buf_Length(L)
		mov		r4, _Fifo_RW_Buf_Length + 1	;R4 : _Fifo_RW_Buf_Length(H)
		;
		;					;Buf_Length == 0ȂI
		mov		A, r5
		orl		A, r4
		jz		_FifoWriteFinish		;Buf_Length == 0ȂWv
		;
_FifoWriteWaitForIdle:					;BUSY`FbN
		mov		A, _USB0ADR
		jb		ACC.7, _FifoWriteWaitForIdle
		;
		mov		_USB0ADR, _Fifo_RW_Ep_Address	;WX^AhXZbg
		;
		;					;|C^ẅɂ菈𕪊
		mov		A, _Fifo_RW_Buf_Ptr + 2		;A : WFlbN|C^̍ŏʃoCg
		jz		_FifoWriteXdata			;A == 0x00ȂXSEG
		;
		cjne		A, #0x40, 1$
		ljmp		_FifoWriteIdata			;A == 0x40ȂDSEG, ISEG
		;
1$:		cjne		A, #0x80, 2$
		ljmp		_FifoWriteCode			;A == 0x80ȂCODE
		;
2$:		sjmp		.				;loop forever on fatal
		;
_FifoWriteXdata:					;XDATÄ悩FIFOփCg
		mov		DPH, _Fifo_RW_Buf_Ptr + 1
		mov		DPL, _Fifo_RW_Buf_Ptr		;DPTR : f[^|C^
		;
		;					;Buf_Length(L) != 0ȂR41ZĂ
		mov		A, r5
		jz		_FifoWriteXdataLoop
		;
		inc		r4				;r4 += 1
		;
_FifoWriteXdataLoop:					;f[^][v
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoWriteXdataLoop
		;
		movx		A, @DPTR			;A : Cgf[^
		mov   		_USB0DAT, A			;FIFO֓]
		inc		DPTR				;|C^XV
		djnz		r5, _FifoWriteXdataLoop
		;
		djnz		r4, _FifoWriteXdataLoop
		;
_FifoWriteFinish:					;I
		pop		DPH
		pop		DPL
		pop		ACC
		mov		R5, A
		pop		ACC
		mov		R4, A
		pop		ACC
		mov		R0, A
		pop		ACC
		;
		ret					;^[
		;
_FifoWriteIdata:					;IDATÄ悩FIFOփCg
		mov		r0, _Fifo_RW_Buf_Ptr		;r0 : f[^|C^
		;
_FifoWriteIdataLoop:					;f[^][v
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoWriteIdataLoop
		;
		mov		A, @r0				;A : Cgf[^
		mov   		_USB0DAT, A			;FIFO֓]
		inc		r0				;|C^XV
		djnz		r5, _FifoWriteIdataLoop
		;
		sjmp		_FifoWriteFinish	;I
		;
_FifoWriteCode:						;CODË悩FIFOփCg
		mov		DPH, _Fifo_RW_Buf_Ptr + 1
		mov		DPL, _Fifo_RW_Buf_Ptr		;DPTR : f[^|C^
		;
		;					;Buf_Length(L) != 0ȂR41ZĂ
		mov		A, r5
		jz		_FifoWriteCodeLoop
		;
		inc		r4				;r4 += 1
		;
_FifoWriteCodeLoop:					;f[^][v
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoWriteCodeLoop
		;
		clr		A
		movc		A, @A + DPTR			;A : Cgf[^
		mov   		_USB0DAT, A			;FIFO֓]
		inc		DPTR				;|C^XV
		;
		djnz		r5, _FifoWriteCodeLoop
		;
		djnz		r4, _FifoWriteCodeLoop
		;
		sjmp		_FifoWriteFinish	;I
		;
;-------------------------------------------------------------------------------
; 	function Fifo_Read
;
;	__data Fifo_RW_Buf_Ptr : pchar
;	__data Fifo_RW_Buf_Length : buffer length
;	__data Fifo_RW_Ep_Address : register address
;

_Fifo_Read:
		push		ACC
		mov		A, R0
		push		ACC
		mov		A, R4
		push		ACC
		mov		A, R5
		push		ACC
		push		DPL
		push		DPH
		;
		;					;[LOWX^
		mov		r5, _Fifo_RW_Buf_Length		;R5 : _Fifo_RW_Buf_Length(L)
		mov		r4, _Fifo_RW_Buf_Length + 1	;R4 : _Fifo_RW_Buf_Length(H)
		;
		;					;Buf_Length == 0ȂI
		mov		A, r5
		orl		A, r4
		jz		_FifoReadFinish			;Buf_Length == 0ȂWv
		;
		;					;|C^ẅɂ菈𕪊
		mov		A, _Fifo_RW_Buf_Ptr + 2		;A : WFlbN|C^̍ŏʃoCg
		jz		_FifoReadXdata			;A == 0x00ȂXSEG
		;
		cjne		A, #0x40, 1$
		ljmp		_FifoReadIdata			;A == 0x40ȂDSEG, ISEG
		;
1$:		sjmp		.				;loop forever on fatal
		;
_FifoReadXdata:						;FIFOXDATÄփ[h
		mov		DPH, _Fifo_RW_Buf_Ptr + 1
		mov		DPL, _Fifo_RW_Buf_Ptr		;DPTR : f[^|C^
		;
		;					;Buf_Length(L) != 0ȂR41ZĂ
		mov		A, r5
		jz		_FifoReadXdataLoop
		;
		inc		r4				;r4 += 1
		;
_FifoReadXdataLoop:					;f[^][v
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoReadXdataLoop
		;
		mov		_USB0ADR, _Fifo_RW_Ep_Address	;WX^AhXZbg
		orl		_USB0ADR, #0xc0			;BUSY, AUTORDZbg
		;
_FifoReadXdataLoop1:
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoReadXdataLoop1
		;
		mov		A, _USB0DAT			;A : [hf[^
		movx		@DPTR, A			;f[^]
		inc		DPTR				;|C^XV
		djnz		r5, _FifoReadXdataLoop1
		;
		djnz		r4, _FifoReadXdataLoop1
		;
_FifoReadFinish:					;I
		pop		DPH
		pop		DPL
		pop		ACC
		mov		R5, A
		pop		ACC
		mov		R4, A
		pop		ACC
		mov		R0, A
		pop		ACC
		;
		ret					;^[
		;
_FifoReadIdata:						;FIFOIDATÄփ[h
		mov		r0, _Fifo_RW_Buf_Ptr		;r0 : f[^|C^
		;
_FifoReadIdataLoop:
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoReadIdataLoop
		;
		mov		_USB0ADR, _Fifo_RW_Ep_Address	;WX^AhXZbg
		orl		_USB0ADR, #0xc0			;BUSY, AUTORDZbg
_FifoReadIdataLoop1:
		mov		A, _USB0ADR			;BUSY`FbN
		jb		ACC.7, _FifoReadIdataLoop1
		;
		mov		A, _USB0DAT			;A : [hf[^
		mov		@r0, A				;f[^]
		inc		r0				;|C^XV
		djnz		r5, _FifoReadIdataLoop1
		;
		sjmp		_FifoReadFinish		;I
		;
;------------------------------------------------------------------------------
;	End of TimpyH_MSD_USB_Procedure.asm
;------------------------------------------------------------------------------
